"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const vender_interface_1 = require("../interfaces/vender.interface");
const qiniu = __importStar(require("qiniu"));
class QiNiuVender extends vender_interface_1.VendorStorage {
    constructor(options) {
        super(options);
        this.generatorParams();
    }
    generatorParams() {
        const policyConf = {
            scope: this.options.bucket_name,
        };
        const putPolicy = new qiniu.rs.PutPolicy(policyConf);
        this.token = putPolicy.uploadToken(this.getMac());
        this.config = new qiniu.conf.Config();
        this.config.zone = qiniu.zone[this.options.region];
    }
    upload(key, file, path) {
        return __awaiter(this, void 0, void 0, function* () {
            const formUploader = new qiniu.form_up.FormUploader(this.config);
            const putExtra = new qiniu.form_up.PutExtra();
            return new Promise((resolve, reject) => {
                formUploader.put(this.token, key, file, putExtra, (respErr, respBody, respInfo) => {
                    if (respErr)
                        return reject(respErr);
                    resolve({ respBody, respInfo });
                });
            });
        });
    }
    uploadStream(file, name, buffer) {
        return __awaiter(this, void 0, void 0, function* () {
            throw new Error('Method not implemented.');
        });
    }
    getMac() {
        return new qiniu.auth.digest.Mac(this.ak, this.sk);
    }
}
exports.QiNiuVender = QiNiuVender;
